import { select, arc } from 'd3';

const svg = select('svg');
const height = +svg.attr('height');
const width = parseFloat(svg.attr('width'));

const black = '#222';
const yellow = '#fe0';

const faceSz = 222;

const eyeSz = 30;
const eyeSpacing = 160;
const eyeOffset = -70;

const eyebrowHeight = 15;
const eyebrowWidth = 65;
const eyebrowsRaise = 30;
const raiseDur = 1800;

const mouthOffset = 130;
const lipWidth = 15;
const grin = 1; //1.5707963267948966;

const g = svg.append('g')
  .attr('transform', `translate(${width/2}, ${height/2})`);

const face = g.append('circle')
  .attr('r', faceSz)
  .attr('fill', yellow)
  .attr('stroke', black)
  .attr('stroke-width', 4);

const eyes = g.append('g')
  .attr('transform', `translate(0, ${eyeOffset})`)
  .attr('fill', black);
const leftEye = eyes.append('circle')
  .attr('r', eyeSz)
  .attr('cx', -eyeSpacing/2);
const rightEye = eyes.append('circle')
  .attr('r', eyeSz)
  .attr('cx', eyeSpacing/2);

const eyeBrows = eyes.append('g')
		.attr('transform', `translate(0, 0)`);
function raiseEyeBrows() {
	eyeBrows
    .transition()
      .duration(raiseDur/2)
      .attr('transform', `translate(0, ${-eyebrowsRaise})`)
      .on('end', lowerEyeBrows);
};
function lowerEyeBrows() {
	eyeBrows
    .transition()
      .duration(raiseDur/2)
      .attr('transform', `translate(0, 0)`)
    	.on('end', raiseEyeBrows);
};
raiseEyeBrows();

const leftEyebrow = eyeBrows.append('rect')
  .attr('x', -(eyeSpacing+eyebrowWidth)/2)
  .attr('y', eyeOffset)
  .attr('height', eyebrowHeight)
  .attr('width', eyebrowWidth);
const rightEyebrow = eyeBrows.append('rect')
  .attr('x', (eyeSpacing-eyebrowWidth)/2)
  .attr('y', eyeOffset)
  .attr('height', eyebrowHeight)
  .attr('width', eyebrowWidth)

const mouth = g.append('path')
	.attr('d', arc()({
    innerRadius: mouthOffset,
    outerRadius: mouthOffset + lipWidth,
    startAngle: Math.PI - grin,
    endAngle: Math.PI + grin
	}))
  .attr('fill', black);